%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% \semihalign codes
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [37.786] init_span
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x insert |begin_R_code| at begin of column
if mode=-hmode then space_factor:=1000
@y
if mode=-hmode then begin  space_factor:=1000;
@<insert |begin_R_code| at begin of column@>
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [37.796] fin_col
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x insert matching |end_R_code| at end of column 
  begin adjust_tail:=cur_tail; u:=hpack(link(head),natural); w:=width(u);
@y
  begin adjust_tail:=cur_tail;
@<insert matching |end_R_code| at end of column@>;@/
u:=hpack(link(head),natural); w:=width(u);
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [37.799] fin_row
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x set row justification
  begin p:=hpack(link(head),natural);
@y
  begin p:=hpack(link(head),natural);
   if align_chr=Rtlang then subtype(p):=right_justify
   else subtype(p):=left_justify;
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [37.800]  fin_align 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x introduce |pu| and |pr| to keep predecessor nodes of |u| and |r|
var @!p,@!q,@!r,@!s,@!u,@!v: pointer; {registers for the list operations}
@y
var @!p,@!q,@!r,@!s,@!u,@!v,@!pu,@!pr: pointer;
   {registers for the list operations}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [37.806] running dimention in rule 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x set rule justification in alignment
  shift_amount(q):=o; link(q):=r; link(s):=q;
@y 
  shift_amount(q):=o; link(q):=r; link(s):=q; subtype(q):=subtype(list_ptr(q));
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [37.807] @<Set the unset box |q| and the unset boxes in it@>=
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x append blank boxes and reverse the columns in a row
repeat @<Set the glue in node |r| and change it from an unset node@>;
r:=link(link(r)); s:=link(link(s));
until r=null;
@y
pr:=list_ptr(q); { keep |r| predecessor in |pr| }
repeat @<Set the glue in node |r| and change it from an unset node@>;
pr:=link(r); { ditto }
r:=link(link(r)); s:=link(link(s));
until r=null;
if align_chr=Rtlang then @<Reverse align columns@>;@/
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% @<Set the glue in node |r|...@>=
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x set spanned box width to last column width
if mode=-vmode then
@y
if u<>hold_head then
  if align_chr=Rtlang then begin width(u):=w; w:=width(s); end;
if mode=-vmode then
@z
@x set spanned box as last spanned column
  begin link(u):=link(r); link(r):=link(hold_head); r:=u;
@y
  if align_chr=Rtlang then
       begin link(u):=link(hold_head); link(pu):=r; link(pr):=u; end
  else begin link(u):=link(r); link(r):=link(hold_head); r:=u;
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [37.809] Append tabskip 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x keep last blank box of spanned columns in |pu|
s:=link(s); link(u):=new_null_box; u:=link(u); t:=t+width(s);
@y
s:=link(s); link(u):=new_null_box; pu:=u; u:=link(u); t:=t+width(s);
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% \beginspecial and \endspecial codes
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [39.877] post_line_break
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x LR nodes
prev_graf:=best_line-1;
@y
prev_graf:=best_line-1; @<Flush the LJ stack@>;
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [53.1348]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x  beginspecial_node, endspecial_node
special_node:@<Implement \.{\\special}@>;
@y
special_node,beginspecial_node,endspecial_node:@<Implement \.{\\special}@>;
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [53.1354]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x  special_switch
begin new_whatsit(special_node,write_node_size); write_stream(tail):=null;
p:=scan_toks(false,true); write_tokens(tail):=def_ref;
end
@y
begin i := cur_speech; j := cur_direction; k:=cur_chr;
if not eqspcial then begin cur_speech := Lftlang; cur_direction := L_to_R; 
                     end;
new_whatsit(k,write_node_size);
if k = endspecial_node then
     if is_open_SPC then begin
            p := info (SPCsp); pop_SPC;
            write_tokens(tail):=write_stream (p);
            add_token_ref (write_tokens(tail));
          end
     else begin print_err("Extra \endspecial, ignored");
      help1("\endspecial must be match with \beginspecial.");
      error; write_tokens(tail):=null;
      end
else begin p:=scan_toks(false,true); write_tokens(tail):=def_ref; end;
if k = beginspecial_node then begin
     q:=scan_toks(false,true); write_stream(tail):=def_ref; 
     push_SPC(tail);
    end
else write_stream(tail):=null;
cur_speech := i;  cur_direction := j;
end

@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [54.1376] 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
itself will get a new section number.
@^system dependencies@>
@y
itself will get a new section number.
@^system dependencies@>

@* \[57] ȠϠѾξ.
@d is_open_SPC==(SPCsp<>null)
@d end_LJ(#)==new_LJ(info(#),true)
@d cmd_LJ(#)==new_LJ(info(#),false)
@d whatsit_LJ(#)==((type(#)=whatsit_node) and (subtype(#)>=beginspecial_node)
                   and (subtype(#)<=LR_node))  
@d is_bgn_LJ(#)==(((subtype(#)=LR_node) and is_bgn_LR(#)) or 
                  (subtype(#)=beginspecial_node))
@d is_end_LJ(#)==(((subtype(#)=LR_node) and
                   is_end_LR(LR_command(#)) and 
                   (subtype(info(LJsp))=LR_node) and
                   is_bgn_LR(info(LJsp)) and
                   (LRend(LR_command(info(LJsp)))=LR_command(#))
                  ) or ((subtype(#)=endspecial_node) and
                        (subtype(info(LJsp))=beginspecial_node)))
@d is_open_LJ==(LJsp<>null)

@ @<Flush the LJ stack@>=@<Flush the LR stack@>; while is_open_LJ do pop_LJ

@* \[68] New whatsit.

@<Glob...@>=
@!SPCsp: pointer; {stack of beginspecial nodes}
@!LJsp: pointer; {stack of LR and beginspecial nodes}

@ To appending |beginspecial_node| or |endspecial_node| to
 horizental list we 
 create a |whatsit_node| with subtype |beginspacial_node| or |endspecial_node|.
The |push_SPC| and |pop_SPC| procedures
are used to checking or reinserting these nodes.

For adjusting breaked line |beginspecial_node| and |LR_node| must nest 
properly, so we use |push_LJ| and |pop_LJ| to avoid confusion. 

@<Declare functions needed for special kinds of nodes@>=
procedure push_LJ(p:pointer);
var t:pointer;
begin t:=get_avail; info(t):=p; link(t):=LJsp; LJsp:=t;
end;
@#
procedure pop_LJ;
var t:pointer; begin t:=LJsp;
   if t<>null then begin LJsp:=link(t); free_avail(t); end;
end;
@#
function new_LJ(s:pointer;endflg:boolean): pointer;
var p: pointer;
t:small_number;
begin p:=get_node(write_node_size);
 type(p):=whatsit_node;
  if subtype (s) = beginspecial_node then 
     if endflg then t:=endspecial_node else t:=beginspecial_node
  else t:=LR_node;
  subtype(p):=t;
  if t=endspecial_node then begin
      write_tokens (p):=write_stream (s); add_token_ref(write_tokens (p));
      write_stream (p):=null;
    end
  else if t=beginspecial_node then begin
      write_tokens(p):=write_tokens (s);add_token_ref(write_tokens (p));
      write_stream (p):=write_stream (s);add_token_ref(write_stream (p));
    end
  else begin  t:=LR_command(s); if endflg then t:=LRend(t);
              LR_command (p) := t; LR_source (p) := LR_source (s); end;
 new_LJ:=p;
end;
